%define debug_package		%{nil}

%define rel                     1

%if 0%{?centos} == 7
%define	__python		%(echo which python3 | scl enable rh-python38 -)
%endif

%if 0%{?centos} 
%define VirtualEnvironment      %{name}-%{version}-%{rel}
%define VirtualEnvironmentPath  %{_prefix}/local/lib/PythonVirtualEnvironments

%define _use_internal_dependency_generator 0
%define __find_requires         /tmp/myfind-requires
%endif

%if 0%{?centos}0%{?amzn} == 70
%define python3_pkgversion 36
%endif

%if 0%{?centos} == 8
%define python3_pkgversion 38
%define	_build_id_links none
%endif

########################################################################
# This is the Python 3 version of plaso for Fedora 26-31 and CentOS 7 and 8
########################################################################
Summary:	plaso - Python based back-end engine used by tools such as log2timeline for automatic creation of a super timelines
Packager:	Lawrence R. Rogers (lrr@cert.org)
Vendor:		cert.org
Name:		plaso
Version:	20230717
Release:	%{rel}%{?dist}
License:	Apache License, Version 2.0
Group:		Applications/Forensics Tools
%if 0%{?centos} || 0%{?amzn}
Source1:	%{name}-%{version}.tar.gz
%endif
%if 0%{?fedora} || 0%{?amzn}
Source:		%{name}-%{version}.tar.gz
%endif
URL:		http://plaso.kiddaland.net/

BuildRoot:	%{_tmppath}/rpm-root-%{name}-v%{version}

BuildRequires:	openssl-devel
%if 0%{?amzn} 
BuildRequires:  rh-python36-python-virtualenv
BuildRequires:	rh-python38-python rh-python38-python-devel gcc-c++
Requires:	rh-python38-python
%else
%if 0%{?centos} == 9 || 0%{?rhel} == 9
BuildRequires:	python3-virtualenv python3-devel python3 g++
%endif
%if 0%{?centos} == 8 || 0%{?rhel} == 8
BuildRequires:  python3-virtualenv python3-devel
BuildRequires:	python%{python3_pkgversion} python%{python3_pkgversion}-devel
%endif
%if 0%{?centos} == 7
BuildRequires:  rh-python36-python-virtualenv
BuildRequires:	rh-python38-python rh-python38-python-devel devtoolset-7-gcc-c++
Requires:	rh-python38-python
%endif
%endif 

%if 0%{?fedora} 
BuildRequires:	python%{python3_pkgversion}-devel
########################################################################
# This set of requires has been extracted from the dependencies.ini
# file that is distributed with plaso.
########################################################################
Requires:	python%{python3_pkgversion}
Requires:       libbde-python%{python3_pkgversion} >= 20220121
Requires:       libcaes-python%{python3_pkgversion} >= 20221127
Requires:       libcreg-python%{python3_pkgversion} >= 20200725
Requires:       libesedb-python%{python3_pkgversion} >= 20220806
Requires:       libevt-python%{python3_pkgversion} >= 20191104
Requires:       libevtx-python%{python3_pkgversion} >= 20220724
Requires:       libewf-python%{python3_pkgversion} >= 20131210
Requires:       libfsapfs-python%{python3_pkgversion} >= 20201107
Requires:       libfsext-python%{python3_pkgversion} >= 20220112
Requires:       libfsfat-python%{python3_pkgversion} >= 20220816
Requires:       libfshfs-python%{python3_pkgversion} >= 20220115
Requires:       libfsntfs-python%{python3_pkgversion} >= 20211229
Requires:       libfsxfs-python%{python3_pkgversion} >= 20220113
Requires:       libfvde-python%{python3_pkgversion} >= 20220121
Requires:       libfwnt-python%{python3_pkgversion} >= 20210717
Requires:       libfwsi-python%{python3_pkgversion} >= 20150606
Requires:       liblnk-python%{python3_pkgversion} >= 20230205
Requires:       libluksde-python%{python3_pkgversion} >= 20220121
Requires:       libmodi-python%{python3_pkgversion} >= 20210405
Requires:       libmsiecf-python%{python3_pkgversion} >= 20150314
Requires:       libolecf-python%{python3_pkgversion} >= 20151223
Requires:       libphdi-python%{python3_pkgversion} >= 20220110
Requires:       libqcow-python%{python3_pkgversion} >= 20201213
Requires:       libregf-python%{python3_pkgversion} >= 20201002
Requires:       libscca-python%{python3_pkgversion} >= 20190605
Requires:       libsigscan-python%{python3_pkgversion} >= 20230109
Requires:       libsmdev-python%{python3_pkgversion} >= 20140529
Requires:       libsmraw-python%{python3_pkgversion} >= 20140612
Requires:       libvhdi-python%{python3_pkgversion} >= 20201014
Requires:       libvmdk-python%{python3_pkgversion} >= 20140421
Requires:       libvsgpt-python%{python3_pkgversion} >= 20211115
Requires:       libvshadow-python%{python3_pkgversion} >= 20160109
Requires:       libvslvm-python%{python3_pkgversion} >= 20160109
Requires:       python%{python3_pkgversion}-acstore >= 20230519
Requires:       python%{python3_pkgversion}-artifacts >= 20220219
Requires:       python%{python3_pkgversion}-bencode
Requires:       python%{python3_pkgversion}-certifi >= 2016.9.26
Requires:       python%{python3_pkgversion}-cffi >= 1.9.1
Requires:       python%{python3_pkgversion}-chardet >= 2.0.1
Requires:       python%{python3_pkgversion}-cryptography >= 2.0.2
Requires:       python%{python3_pkgversion}-dateutil >= 1.5
Requires:       python%{python3_pkgversion}-defusedxml >= 0.5.0
Requires:       python%{python3_pkgversion}-dfdatetime >= 20221112
Requires:       python%{python3_pkgversion}-dfvfs >= 20230407
Requires:       python%{python3_pkgversion}-dfwinreg >= 20211207
Requires:       python%{python3_pkgversion}-dtfabric >= 20230518
Requires:       python%{python3_pkgversion}-flor >= 1.1.3
Requires:       python%{python3_pkgversion}-future >= 0.16.0
Requires:       python%{python3_pkgversion}-idna >= 2.5
Requires:       python%{python3_pkgversion}-lz4 >= 0.10.0
Requires:       python%{python3_pkgversion}-opensearch
Requires:       python%{python3_pkgversion}-pefile >= 2021.5.24
Requires:       python%{python3_pkgversion}-psutil >= 5.4.3
Requires:       python%{python3_pkgversion}-pyparsing >= 2.4.2
Requires:       python%{python3_pkgversion}-pyparsing <= 3.1.0
Requires:       python%{python3_pkgversion}-pytsk3 >= 20210419
Requires:       python%{python3_pkgversion}-pytz
Requires:       python%{python3_pkgversion}-pyxattr >= 0.7.2
Requires:       python%{python3_pkgversion}-redis >= 3.4
Requires:       python%{python3_pkgversion}-requests >= 2.18.0
Requires:       python%{python3_pkgversion}-six >= 1.1.0
Requires:       python%{python3_pkgversion}-urllib3 >= 1.21.1
Requires:       python%{python3_pkgversion}-xlsxwriter >= 0.9.3
Requires:       python%{python3_pkgversion}-yara >= 3.4.0
%if 0%{?centos} == 7
Requires:       python%{python3_pkgversion}-PyYAML >= 3.10
%else
Requires:       python%{python3_pkgversion}-pyyaml >= 3.10
%endif
Requires:       python%{python3_pkgversion}-zmq >= 2.1.11
%endif

%description
Plaso (plaso langar að safna öllu) is the Python based back-end engine
used by tools such as log2timeline for automatic creation of a super
timelines. The goal of log2timeline (and thus plaso) is to provide a
single tool that can parse various log files and forensic artifacts from
computers and related systems, such as network equipment to produce a
single correlated timeline. This timeline can then be easily analysed by
forensic investigators/analysts, speeding up investigations by correlating
the vast amount of information found on an average computer system.

Auxiliary goal of plaso is to provide forensic analysts and tool makers
powerful libraries that they can use to access, find, read and parse
various files within disk images to create their own tools, or to adjust
log2timeline to their own workflow, instead of relying on the workflow
provided by log2timeline.py.

%if 0%{?centos} || 0%{?amzn} == 0
This version uses a Python Virtual Environment to make use of Python 3.8.
%endif

%prep
%if 0%{?centos} || 0%{?amzn}
%setup -cT
sudo mkdir -p %{VirtualEnvironmentPath}
sudo chown %(id -u).%(id -g) %{VirtualEnvironmentPath}
cd %{VirtualEnvironmentPath}

%if 0%{?centos} == 7
echo virtualenv -p python3.8 %{VirtualEnvironment} | scl enable rh-python36 rh-python38 -
%endif

%if 0
%if 0%{?centos}0%{?amzn} == 70
virtualenv-3 -p $(echo which python3 | scl enable rh-python38 -) %{VirtualEnvironment}
%endif
%endif

%if 0%{?centos} == 8
virtualenv-3 -p $(which python3.8) %{VirtualEnvironment}
%endif

%if 0%{?centos} == 9
virtualenv -p $(which python3) %{VirtualEnvironment}
%endif

cd %{VirtualEnvironment}
tar zxf %{SOURCE1}
cat > %{__find_requires} <<EOF
#!/bin/sh
grep -v %{VirtualEnvironmentPath} | /usr/lib/rpm/rpmdeps --define="_use_internal_dependency_generator 1" --requires
EOF
chmod 755 %{__find_requires}
%endif

%if 0%{?fedora}
%setup
%endif

%build
%if 0%{?centos} > 0
cd %{VirtualEnvironmentPath}
%if 0%{?amzn} == 0
sh -c "cd %{VirtualEnvironment}; source bin/activate; pip3 install setuptools-rust; pip3 install --upgrade pip"
%else
sh -c "cd %{VirtualEnvironment}; source bin/activate; pip3 install --upgrade pip"
%endif

%if 0%{?amzn} || 0%{?centos} == 8 || 0%{?centos} == 9
sh -c "cd %{VirtualEnvironment}; source bin/activate; pip3 install -r %{name}-%{version}/requirements.txt"
%endif

%if 0%{?centos}0%{?amzn} == 70
sh -c "cd %{VirtualEnvironment}; sed -i '/yara-python/s/$/, < 4.3.0/' %{name}-%{version}/requirements.txt; source bin/activate; echo pip3 install -r %{name}-%{version}/requirements.txt | scl enable devtoolset-7 -"
%endif

sh -c "cd %{VirtualEnvironment}; source bin/activate; cd %{name}-%{version}; python3 setup.py build"
%endif

%if 0%{?fedora}
%py3_build
%endif

%install
%if 0%{?centos}
cd %{VirtualEnvironmentPath}
sh -c "cd %{VirtualEnvironment}; source bin/activate; cd %{name}-%{version}; python3 setup.py install"
rm -rf %{VirtualEnvironment}/%{name}-%{version}
%{__mkdir_p} %{buildroot}/%{VirtualEnvironmentPath}
rsync -a --sparse %{VirtualEnvironment} %{buildroot}%{VirtualEnvironmentPath}
rm -rf %{VirtualEnvironment}

mkdir -p %{buildroot}/%{_bindir}
cat > %{buildroot}/%{_bindir}/log2timeline.py << 'EOF'
#!/bin/sh

N=$(basename $0)
MA=%{VirtualEnvironment}
VE=%{VirtualEnvironmentPath}

if [ -d $VE ]; then
        case "$N" in
        *.py)
                ;;
        *)
                N=$N.py
                ;;
        esac
        source $VE/$MA/bin/activate
        exec python3 $VE/$MA/bin/$N "$@"
else
        echo $0 cannot be found
        exit 2
fi
EOF
for app in {image_export,pinfo,psort,psteal}.py
do
        ln %{buildroot}/%{_bindir}/log2timeline.py %{buildroot}/%{_bindir}/$app
done
%endif

%if 0%{?fedora}
%py3_install
rm -rf %{buildroot}%{_datadir}/doc/%{name}
%endif

%clean
%{__rm} -rf %{buildroot}

%files
%if 0%{?centos}
%defattr(0644, root, root, 0755)
%attr(0755,root,root)   %{_bindir}/*
%attr(0755,root,root)   %{VirtualEnvironmentPath}/%{VirtualEnvironment}/bin/*
%{VirtualEnvironmentPath}/%{VirtualEnvironment}
%endif

%if 0%{?fedora}
%defattr(644,root,root,755)
%license LICENSE
%doc ACKNOWLEDGEMENTS AUTHORS README LICENSE
%{python3_sitelib}/plaso/*.py
%{python3_sitelib}/plaso/*/*.py
%{python3_sitelib}/plaso/*/*.yaml
%{python3_sitelib}/plaso/*/*/*.py
%{python3_sitelib}/plaso/*/*/*.yaml
%{python3_sitelib}/plaso*.egg-info/*
%attr(0755, root, root)	%{_bindir}/*.py
%{_datadir}/%{name}/*

%exclude %{python3_sitelib}/plaso/*/*.pyc
%exclude %{python3_sitelib}/plaso/*/*/*.pyc
%exclude %{python3_sitelib}/plaso/__pycache__/*
%exclude %{python3_sitelib}/plaso/*/__pycache__/*
%exclude %{python3_sitelib}/plaso/*/*/__pycache__/*
%endif

%changelog
* Mon Jul 17 2023 Lawrence R. Rogers <lrr@cert.org> 20230717-1
* Release 20230717-1
	Version from 20230717
	Updated dependencies

* Sat Mar 11 2023 Lawrence R. Rogers <lrr@cert.org> 20230311-1
* Release 20230311-1
	Version from 20230311
	Updated dependencies

* Sun Feb 26 2023 Lawrence R. Rogers <lrr@cert.org> 20230226-1
* Release 20230226-1
	Version from 20230226
	Updated dependencies

* Sun Jul 24 2022 Lawrence R. Rogers <lrr@cert.org> 20220724-1
* Release 20220724-1
	Version from 20220724
	Updated dependencies

* Thu Apr 28 2022 Lawrence R. Rogers <lrr@cert.org> 20220428-1
* Release 20220428-1
	Version from 20220428
	Updated dependencies

* Sat Jan 29 2022 Lawrence R. Rogers <lrr@cert.org> 20220129-1
* Release 20220129-1
	Version from 20220129

* Mon Jan 24 2022 Lawrence R. Rogers <lrr@cert.org> 20211229-3
* Release 20211229-3
	Version from 20211229
	Removed the maximum version of pyparsing

* Sat Dec 11 2021 Lawrence R. Rogers <lrr@cert.org> 20211024-2
* Release 20211024-2
	Version from 20211024
	Release 2 build Plaso in a virtual environment for CentOS/RHEL. The Fedora version is unchanged.

* Sun Oct 24 2021 Lawrence R. Rogers <lrr@cert.org> 20211024-1
* Release 20211024-1
	Version from 20211024

* Sun Jun  6 2021 Lawrence R. Rogers <lrr@cert.org> 20210606-1
* Release 20210606-1
	Version from 20210606

* Thu Jun  3 2021 Lawrence R. Rogers <lrr@cert.org> 20210412-2
* Release 20210412-2
	Version from 20210412
	Removed restriction on elasticsearch7

* Mon Apr 12 2021 Lawrence R. Rogers <lrr@cert.org> 20210412-1
* Release 20210412-1
	Version from 20210412

* Sat Feb 13 2021 Lawrence R. Rogers <lrr@cert.org> 20210213-1
* Release 20210213-1
	Version from 20210213
	Updated dependencies

* Sat Feb 13 2021 Lawrence R. Rogers <lrr@cert.org> 20201228-2
* Release 20201228-2
	Removed elasticsearch 7.11 patch
	Specified that elasticsearch version must be less than 7.10

* Mon Dec 28 2020 Lawrence R. Rogers <lrr@cert.org> 20201228-1
* Release 20201228-1
	Version from 20201228
	Updated dependencies

* Wed Oct  7 2020 Lawrence R. Rogers <lrr@cert.org> 20201007-1
* Release 20201007-1
	Version from 20201007
	Updated dependencies

* Fri Jul 17 2020 Lawrence R. Rogers <lrr@cert.org> 20200717-1
* Release 20200717-1
	Version from 20200717

* Tue Jun 30 2020 Lawrence R. Rogers <lrr@cert.org> 20200630-1
* Release 20200630-1
	Version from 20200630

* Thu Apr 30 2020 Lawrence R. Rogers <lrr@cert.org> 20200430-1
* Release 20200430-1
	Version from 20200430

* Thu Feb 27 2020 Lawrence R. Rogers <lrr@cert.org> 20200227-1
* Release 20200227-1
	Version from 20200227

* Tue Jan 21 2020 Lawrence R. Rogers <lrr@cert.org> 20200121-1
* Release 20200121-1
	Version from 20200121

* Tue Dec  3 2019 Lawrence R. Rogers <lrr@cert.org> 20191203-1
* Release 20191203-1
	Version from 20191203

* Mon Sep 16 2019 Lawrence R. Rogers <lrr@cert.org> 20190916-1
* Release 20190916-1
	Version from 20190916

* Mon Jul  8 2019 Lawrence R. Rogers <lrr@cert.org> 20190708-1
* Release 20190708-1
	Version from 20190708

* Fri May 31 2019 Lawrence R. Rogers <lrr@cert.org> 20190531-1
* Release 20190531-1
	Version from 20190531

* Fri May 31 2019 Lawrence R. Rogers <lrr@cert.org> 20190531-1
* Release 20190531-1
	Version from 20190531

* Sun May 19 2019 Lawrence R. Rogers <lrr@cert.org> 20190429-1
* Release 20190429-1
	Version from 20190429

* Fri May 17 2019 Lawrence R. Rogers <lrr@cert.org> 20190331-3
* Release 20190331-3
	CentOS/RHEL 7 is no longer implemented as a  virtual environment.

* Mon May  6 2019 Lawrence R. Rogers <lrr@cert.org> 20190331-2
* Release 20190331-2
	This is the Python 3 version of plaso for Fedora 26-30 and
	  Python 2 in a virtual environment for CentOS/RHEL 7 and Fedora 24-25.

* Sun Mar 31 2019 Lawrence R. Rogers <lrr@cert.org> 20190331-1
* Release 20190331-1
	Version 20190331
		Log output from tools will be output to a file by default, and not just printed to the terminal.
		There’s a new --troubles option, which provides some debugging and troubleshooting information
		A lot of bug fixes and improvements in the Artifact filter support
		Elasticsearch5 support has been removed, as this version is now at end-of-life
		Efilter support has also been removed

* Sat Feb  2 2019 Lawrence R. Rogers <lrr@cert.org> 20190131-1
* Release 20190131-1
	Version 20190331
	Added missing lzma dependency.

* Tue Jan 29 2019 Lawrence R. Rogers <lrr@cert.org> 20181219-5
* Release 20181219-5
	Version 20181219
	Built for Python 2 and 3.
	Uses the python2/python3 names for dependencies.

* Fri Jan 25 2019 Lawrence R. Rogers <lrr@cert.org> 20181219-4
* Release 20181219-4
	Changed dependencies for pytsk3, dfvfs, dtfabric, and dfwinreg.

* Thu Jan 10 2019 Lawrence R. Rogers <lrr@cert.org> 20181219-3
* Release 20181219-3
	For CentOS/RHEL 7, Python 2.7.13 from centos-release-scl-rh is now required.
	To that end, all of the invocation of programs now uses SCL.

* Tue Jan  8 2019 Lawrence R. Rogers <lrr@cert.org> 20181219-2
* Release 20181219-2
	Added an update-plaso script to update the modules loaded via pip (Fedora 24, 25 and CentOS/RHEL 7).
	Changed the name of the Virtual Envronment folder to remove the version of plaso.

* Wed Dec 19 2018 Lawrence R. Rogers <lrr@cert.org> 20181219-1
* Release 20181219-1
	Version 20181219.
	For Fedora 26 and beyond, this is a traditional app.
	For Fedora 25 and 25 and CentOS/RHEL 7, the installed programs use a Python Virtual Environment.

* Sun Sep 30 2018 Lawrence R. Rogers <lrr@cert.org> 20180930-1
* Release 20180930-1
	Version 20180930.

* Sat Aug 18 2018 Lawrence R. Rogers <lrr@cert.org> 20180818-1
* Release 20180818-1
	Version 20180818.

* Tue Jul  3 2018 Lawrence R. Rogers <lrr@cert.org> 20180703-1
* Release 20180703-1
	Version 20180703.

* Sat Jun 30 2018 Lawrence R. Rogers <lrr@cert.org> 20180630-1
* Release 20180630-1
	Version 20180630.

* Fri May 25 2018 Lawrence R. Rogers <lrr@cert.org> 20180524-1
* Release 20180524-1
	Version 20180524.

* Sat Jan 27 2018 Lawrence R. Rogers <lrr@cert.org> 20180127-1
* Release 20180127-1
	Version 20180127.

* Sat Nov 18 2017 Lawrence R. Rogers <lrr@cert.org> 20171118-1
* Release 20171118-1
	Version 20171118.

* Sat Sep 30 2017 Lawrence R. Rogers <lrr@cert.org> 20170930-1
* Release 20170930-1
	Version 20170930.

* Mon Sep 19 2016 Lawrence R. Rogers <lrr@cert.org> 1.5.1-1
* Release 1.5.1-1
	Version 1.5.1

* Mon Sep 19 2016 Lawrence R. Rogers <lrr@cert.org> 1.5.0-1
* Release 1.5.0-1
	Version 1.5.0
	See this blog post: http://blog.kiddaland.net/2016/09/what-flies-there-what-fares-there-or.html

* Tue Jul 26 2016 Lawrence R. Rogers <lrr@cert.org> 1.4.0-4
* Release 1.4.0-4
	This is the real plaso 1.4.0.

* Sun Feb  7 2016 Lawrence R. Rogers <lrr@cert.org> 1.4-3
* Release 1.4-3
	Added missing dependencies of xlsxwriter.

* Fri Feb  5 2016 Lawrence R. Rogers <lrr@cert.org> 1.4-2
* Release 1.4-2
	Added missing dependencies of dfwinreg and libscca-python.

* Sat Jan 23 2016 Lawrence R. Rogers <lrr@cert.org> 1.4-1
* Release 1.4-1
	Version 1.4 - see http://blog.kiddaland.net/2016/01/sprinkling-morning-dew-and-summer.html for details.

* Mon Sep 21 2015 Lawrence R. Rogers <lrr@cert.org> 1.3.0-2
* Release 1.3.0-2
	Added the artifacts and requests dependencies.

* Wed Jul 22 2015 Lawrence R. Rogers <lrr@cert.org> 1.3.0-1
* Release 1.3.0-1
	Version 1.3.0 - see http://blog.kiddaland.net/2015/07/bringing-end-to-sorrow-new-plaso-release.html for details.

* Wed Dec 24 2014 Lawrence R. Rogers <lrr@cert.org> 1.2.0-2
* Release 1.2.0-2
	Patch to bring up to date to the development release dated 2014-12-24.

* Sat Dec 20 2014 Lawrence R. Rogers <lrr@cert.org> 1.2.0-1
	Version 1.2.0 - see http://blog.kiddaland.net/2014/12/hey-kids-i-heard-on-news-that-airline.html for details.

* Tue Sep 23 2014 Lawrence R. Rogers <lrr@cert.org> 1.1.0-2
	Added correct ipython dependencies

* Fri Jun 06 2014 Lawrence R. Rogers <lrr@cert.org> 1.1.0-1
	See http://blog.kiddaland.net/2014/06/what-is-one-to-say-about-june-time-of.html for the list of changes

* Thu May 22 2014 Lawrence R. Rogers <lrr@cert.org> 1.0.2-1
	See http://blog.kiddaland.net/2013/10/halloween-brings-with-it-riding-witches.html for more details.

	New Shiny Parsers
		Java IDX.
		LS Quarantine.
		MacKeeper cache.
		OLECF (think .doc and so many other OLE compound files on any given Windows system).
		OpenXML.
		Pcap files.
		Plist parser (generic and a plugin interface for new parsers).
		Apple Safari history parser.
		SkyDrive log files.
		Skype text conversations.
		Windows Firewall.
		Windows Job files (think at jobs).
		Windows Prefetch files (supports all versions of Windows).
		Windows Recycle bin (INFO2 and $I/$R).
		Xchat Scroll back files.
		Zeitgeist parser (Linux).
		Several new Windows Registry plugins.
	New Output Modules
		MySQL db output for 4n6time (still an experimental feature and mostly applicable in 4n6time).
		Dynamic. The new default output module for psort. In short this is a simple CSV file that has
			configurable fields to make output more flexible. See additional information here.
		Pstorage - The ability to output again into another instance of a plaso storage.
			This is mainly if you want to keep events fully sorted and filtered out for a new instance.
	New Features
		There are plenty of new features, some of which are listed here:
		New front-end called plasm that as of now takes care of tagging/categorization of your output data.
		New script included called "image_export" that can be used to export files out of an image file (including within VSS)
			either by supplying it with a list of paths or file extensions.
		A PoC tool called "plaso_extract_search_history.py" (not included in the build files) that can read over a plaso storage
			file and extract all search history from it (this will be incorporated into the tool in the next version).
		The ability to define "time slices" in psort. That is if you have a specific pivot point into the data set (as in a time)
			you can define it and get all the surrounding events that occurred on the timeline for X minutes before and after
			(X is configurable but defaults to 5 minutes).
		The ability to include surrounding events for filter hits. That is to create a time slice for every filter hit. Let's say
			you want to filter the timeline for every time a particular web site was visited and at the same time you would like
			to X number of events that led up to that web site visit and the next X subsequent events as well, now that can be easily done.
		Psort now removes duplicate entries.
		You can now bypass the storage mechanism and directly output to file. Before that you had to first store all events into a plaso storage
			file (still default and still recommended). However the option of bypassing the storage mechanism and directly storing the data
			into whatever available output module has been added.
		A new front-end called preg added that can be used to directly parse registry files and present the output in a different manner than is
			done in the main front-end log2timeline/psort (and even works on live machines).
	Back-end Changes
		A timestamp index was added to the backend storage (pstorage) making date based filtering considerably faster.
		Registry plugin infrastructure received a healthy code refactor.
		A new text based assistant added (using pyparsing).
		A new binary assistant added.
		TSK updated to 4.1.x (used to be dependent on 3.x).
		Protobufs updated to version 2.5 (used to be 2.4).
		Quite a few re-factors on various pieces of the codebase.

* Thu Feb 13 2014 Lawrence R. Rogers <lrr@cert.org> 1.0.1alpha-1
	Initial version
